{ Marco Cantu' (author of Master Delphi x and Delphi Developers Handbook has   }
{ released an excellent run-time object inspector tool as freeware.  It can be }
{ found in the Delphi Developers Handbook (highly recommended) and on his web  }
{ site at http://www.marcocantu.com.  If you have this installed, you can      }
{ enable the following define (remove the period) to use it in the demo.       }
{ It is for Delphi 3 only, but I think he has a beta for Delphi 2.             }
{.$DEFINE DFS_RUN_TIME_DEBUGGER}

unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  {$IFDEF DFS_RUN_TIME_DEBUGGER}
  DdhObjDb,
  {$ENDIF}
  Forms, Dialogs, StdCtrls, IconCtls;

type
  TForm1 = class(TForm)
    IconComboBox: TdfsIconComboBox;
    IconListBox: TdfsIconListBox;
    Label1: TLabel;
    Edit1: TEdit;
    savdlgExtract: TSaveDialog;
    btnExtractLBIcon: TButton;
    btnExtractCBIcon: TButton;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnExtractLBIconClick(Sender: TObject);
    procedure btnExtractCBIconClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if FileExists(Edit1.Text) then begin
    IconComboBox.FileName := Edit1.Text;
    IconListBox.FileName := Edit1.Text;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DFS_RUN_TIME_DEBUGGER}
  TDdhObjectDebugger.Create(Self);
  {$ENDIF}
end;

procedure TForm1.btnExtractLBIconClick(Sender: TObject);
var
  AnIcon: TIcon;
begin
  if IconListBox.ItemIndex >= 0 then
  begin
    AnIcon := IconListBox.Icon[IconListBox.ItemIndex];
    { AnIcon belongs to component, don't free it! }
    if AnIcon <> NIL then
    begin
      if savdlgExtract.Execute then
      begin
        AnIcon.SaveToFile(savdlgExtract.Filename);
      end;
    end else
      MessageDlg('Icon list corrupt', mtError, [mbOK], 0);
  end else
    MessageDlg('No icon selected in listbox.', mtError, [mbOK], 0);
end;

procedure TForm1.btnExtractCBIconClick(Sender: TObject);
var
  AnIcon: TIcon;
begin
  if IconComboBox.ItemIndex >= 0 then
  begin
    AnIcon := IconComboBox.Icon[IconComboBox.ItemIndex];
    { AnIcon belongs to component, don't free it! }
    if AnIcon <> NIL then
    begin
      if savdlgExtract.Execute then
      begin
        AnIcon.SaveToFile(savdlgExtract.Filename);
      end;
    end else
      MessageDlg('Icon list corrupt', mtError, [mbOK], 0);
  end else
    MessageDlg('No icon selected in combobox.', mtError, [mbOK], 0);
end;

end.

